<template>
  <Navbar />
  <SubNavbar />
  <div class="container">
    <h1><span style="color:yellow">▏</span> Admin</h1>
    <p>The master admin can add and remove other admins as needed. Deletion will have permanent consequences!</p>

    <button id="add-admin" @click="showAddAdminForm = true">Tambah Admin</button>

    <div v-if="showAddAdminForm" class="modal">
      <div class="modal-content">
        <span @click="showAddAdminForm = false" class="close">&times;</span>
        <h2>Tambah Admin Baru</h2>
        <form @submit.prevent="addAdmin">
          <div>
            <label for="name">Name:</label>
            <input type="text" v-model="newAdmin.name" required />
          </div>
          <div>
            <label for="email">Email:</label>
            <input type="email" v-model="newAdmin.email" required />
          </div>
          <div>
            <label for="password">Password:</label>
            <input type="password" v-model="newAdmin.password" required />
          </div>
          <button type="submit">Tambah</button>
        </form>
      </div>
    </div>

    <div class="table-list">
      <table style="margin-bottom: 10px;">
        <thead>
          <tr>
            <th style="width: 25%;">Username</th>
            <th style="width: 25%">Email</th>
            <th style="width: 25%">Role</th>
            <th style="width: 25%">Action</th>
          </tr>
        </thead>
      </table>

      <table>
        <tbody>
          <tr v-for="user in dataResponse" :key="user.id">
            <td style="width: 25%">{{ user.name }}</td>
            <td style="width: 25%">{{ user.email }}</td>
            <td style="width: 25%">{{ user.role || 'User' }}</td>
            <td style="width: 25%">
              <button @click="removeAdmin(user.id)">Remove</button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>

    <div v-if="error" class="error-message">
      {{ error }}
    </div>
  </div>
</template>

<script>
import Navbar from '@/components/Navbar.vue';
import SubNavbar from '@/components/SubNavbar.vue';
import axios from 'axios';
import { useRouter } from 'vue-router';
import { ref, onMounted } from 'vue';

export default {
  name: 'AdminList',
  components: {
    Navbar, SubNavbar
  },
  setup() {
    const URL = 'http://localhost:8000';
    const dataResponse = ref([]);
    const error = ref(null);
    const showAddAdminForm = ref(false);
    const router = useRouter()
    const newAdmin = ref({
      name: '',
      email: '',
      password: '',
      role: 'Admin'
    });

    async function fetchDatas() {
      const token = window.localStorage.getItem('jwt-token')
      if(token){
        try {
          const response = await axios.get(`${URL}/api/listAdmin`,{
            headers : {
                Accept : 'application/json',
                Authorization : `Bearer ${token}`
            },

          });
          dataResponse.value = response.data.users;
        } catch (err) {
          console.error(err);
          router.push('/login')
        }
      }else{
        router.push('/login')
      }
    }

    async function removeAdmin(id) {
      try {
        await axios.delete(`${URL}/api/admin/${id}`);
        dataResponse.value = dataResponse.value.filter(user => user.id !== id);
      } catch (err) {
        console.error(err);
        error.value = 'Failed to remove admin';
      }
    }

    async function addAdmin() {
      try {
        const response = await axios.post(`${URL}/api/admin`, newAdmin.value);
        dataResponse.value.push(response.data.user);
        showAddAdminForm.value = false;
        newAdmin.value = { name: '', email: '', password: '', role: 'Admin' };
      } catch (err) {
        console.error(err);
        error.value = 'Failed to add admin';
      }
    }

    onMounted(fetchDatas);

    return {
      dataResponse,
      error,
      removeAdmin,
      showAddAdminForm,
      newAdmin,
      addAdmin
    };
  }
};
</script>

<style>
body {
  background: #030814;
}

.container {
  color: white;
  padding: 20px;
}

table {
  width: 100%;
  border-collapse: collapse;
}

th, td {
  border: 1px solid #202938;
  padding: 8px;
  text-align: center;
  background-color: #111828;
}

.table-list {
  background-color: #202938;
  padding: 20px 30px;
  border-radius: 10px;
  margin-top: 20px;
}

button {
  margin-right: 5px;
  padding: 5px 10px;
  background-color: #8A2E2E;
  color: white;
  border: none;
  border-radius: 5px;
  cursor: pointer;
}

button:hover {
  background-color: #202938;
}

.error-message {
  color: red;
  margin-top: 10px;
}

.modal {
  display: block;
  position: fixed;
  z-index: 1;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  overflow: auto;
  background-color: rgba(0, 0, 0, 0.5);
}

.modal-content {
  background-color: #202938;
  margin: 15% auto;
  padding: 20px;
  border: 1px solid #888;
  width: 50%;
  border-radius: 10px;
}

.close {
  color: #aaa;
  float: right;
  font-size: 28px;
  font-weight: bold;
}

.close:hover,
.close:focus {
  color: white;
  text-decoration: none;
  cursor: pointer;
}
</style>
